# Packing (Operations)

These endpoints facilitate the packing process.

## List packing container types

> This part of the API is deprecated. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Get all packing container types, use operative container types

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"These endpoints facilitate the packing process.","name":"Packing (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"PackingContainerType":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"description":{"type":"string"},"dimensions":{"$ref":"#/components/schemas/ContainerDimensions"},"iconUrl":{"description":"","type":"string"},"id":{"description":"","type":"string"},"name":{"type":"string"},"priority":{"description":"This value gives the priority of the respective packingContainerType. The lower the value the higher is the priority, e.g. priority 1 is higher than priority 10. The priority can be used to order packingContainerTypes in the UI.","format":"int32","maximum":10000,"minimum":1,"type":"integer"},"weightLimitInG":{"description":"Maximal weight in gramm(gr) the container can be loaded with. ","minimum":1,"type":"number"}},"required":["id","version","nameLocalized"],"type":"object","title":"PackingContainerType","description":"PackingContainerType"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ContainerDimensions":{"additionalProperties":false,"properties":{"heightInCm":{"description":"The height of the container (in cm)","type":"number"},"lengthInCm":{"description":"The length of the container (in cm)","type":"number"},"weightInG":{"description":"The weight of the container (in g)","type":"number"},"widthInCm":{"description":"The width of the container (in cm)","type":"number"}},"type":"object","title":"ContainerDimensions","description":"ContainerDimensions"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/packingcontainertypes":{"get":{"deprecated":true,"description":"This part of the API is deprecated. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Get all packing container types, use operative container types","operationId":"getPackingContainerTypes","parameters":[{"description":"Provide the localized values for the entity. If not provided the default locale is used. For example de_DE.","in":"query","name":"locale","schema":{"type":"string"}},{"description":"all entities after given id","in":"query","name":"startAfterId","required":false,"schema":{"type":"string"}},{"description":"number of entities to show","in":"query","name":"size","required":false,"schema":{"default":25,"type":"integer"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/PackingContainerType"},"type":"array"}}},"description":"Found PackingContainerTypes"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Invalid input. See response for details"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"List packing container types","tags":["Packing (Operations)"]}}}}
```

## Create packing container type

> This part of the API is deprecated. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Add a new packing container type, use operative container types.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"These endpoints facilitate the packing process.","name":"Packing (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"PackingContainerTypeForCreation":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"dimensions":{"$ref":"#/components/schemas/ContainerDimensions"},"icon":{"$ref":"#/components/schemas/NamedFile"},"priority":{"description":"This value gives the priority in the respective packingContainerType. The lower the value the higher is the priority, e.g. priority 1 is higher than priority 10. The priority can be used to order packingContainerTypes.","format":"int32","maximum":10000,"minimum":1,"type":"integer"},"weightLimitInG":{"description":"Maximal weight in gramm(gr) the container can be loaded with. ","minimum":1,"type":"number"}},"required":["nameLocalized"],"type":"object","title":"PackingContainerTypeForCreation","description":"PackingContainerTypeForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ContainerDimensions":{"additionalProperties":false,"properties":{"heightInCm":{"description":"The height of the container (in cm)","type":"number"},"lengthInCm":{"description":"The length of the container (in cm)","type":"number"},"weightInG":{"description":"The weight of the container (in g)","type":"number"},"widthInCm":{"description":"The width of the container (in cm)","type":"number"}},"type":"object","title":"ContainerDimensions","description":"ContainerDimensions"},"NamedFile":{"additionalProperties":false,"properties":{"content":{"description":"File content base64 encoded","type":"string"},"name":{"description":"File name with extension","type":"string"}},"required":["name","content"],"type":"object","xml":{"name":"NamedFile"},"title":"NamedFile","description":"NamedFile"},"PackingContainerType":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"description":{"type":"string"},"dimensions":{"$ref":"#/components/schemas/ContainerDimensions"},"iconUrl":{"description":"","type":"string"},"id":{"description":"","type":"string"},"name":{"type":"string"},"priority":{"description":"This value gives the priority of the respective packingContainerType. The lower the value the higher is the priority, e.g. priority 1 is higher than priority 10. The priority can be used to order packingContainerTypes in the UI.","format":"int32","maximum":10000,"minimum":1,"type":"integer"},"weightLimitInG":{"description":"Maximal weight in gramm(gr) the container can be loaded with. ","minimum":1,"type":"number"}},"required":["id","version","nameLocalized"],"type":"object","title":"PackingContainerType","description":"PackingContainerType"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/packingcontainertypes":{"post":{"deprecated":true,"description":"This part of the API is deprecated. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Add a new packing container type, use operative container types.","operationId":"addPackingContainerType","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PackingContainerTypeForCreation"}}},"description":"Packing type object","required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PackingContainerType"}}},"description":"The packing container type was successfully created. The Location header contains the URL of the packing container type."},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Invalid input. See response for details"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"Create packing container type","tags":["Packing (Operations)"]}}}}
```

## Get packing container type

> This part of the API is deprecated. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"These endpoints facilitate the packing process.","name":"Packing (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"PackingContainerType":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"description":{"type":"string"},"dimensions":{"$ref":"#/components/schemas/ContainerDimensions"},"iconUrl":{"description":"","type":"string"},"id":{"description":"","type":"string"},"name":{"type":"string"},"priority":{"description":"This value gives the priority of the respective packingContainerType. The lower the value the higher is the priority, e.g. priority 1 is higher than priority 10. The priority can be used to order packingContainerTypes in the UI.","format":"int32","maximum":10000,"minimum":1,"type":"integer"},"weightLimitInG":{"description":"Maximal weight in gramm(gr) the container can be loaded with. ","minimum":1,"type":"number"}},"required":["id","version","nameLocalized"],"type":"object","title":"PackingContainerType","description":"PackingContainerType"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ContainerDimensions":{"additionalProperties":false,"properties":{"heightInCm":{"description":"The height of the container (in cm)","type":"number"},"lengthInCm":{"description":"The length of the container (in cm)","type":"number"},"weightInG":{"description":"The weight of the container (in g)","type":"number"},"widthInCm":{"description":"The width of the container (in cm)","type":"number"}},"type":"object","title":"ContainerDimensions","description":"ContainerDimensions"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/packingcontainertypes/{packingContainerTypeId}":{"get":{"deprecated":true,"description":"This part of the API is deprecated. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />","operationId":"getPackingContainerType","parameters":[{"description":"Provide the localized values for the entity. If not provided the default locale is used. For example de_DE.","in":"query","name":"locale","schema":{"type":"string"}},{"description":"id of entity","in":"path","name":"packingContainerTypeId","required":true,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PackingContainerType"}}},"description":"Found PackingContainerType"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Invalid input. See response for details"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"Get packing container type","tags":["Packing (Operations)"]}}}}
```

## Update packing container type

> This part of the API is deprecated. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Patches a PackingContainerType with the given ID, use operative container types

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"These endpoints facilitate the packing process.","name":"Packing (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"PackingContainerTypePatchActions":{"properties":{"actions":{"items":{"anyOf":[{"$ref":"#/components/schemas/ModifyPackingContainerType"},{"$ref":"#/components/schemas/ModifyPackingContainerTypeIcon"}]},"minItems":1,"type":"array"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version","actions"],"type":"object","xml":{"name":"PackingContainerTypePatchActions"},"title":"PackingContainerTypePatchActions","description":"PackingContainerTypePatchActions"},"ModifyPackingContainerType":{"allOf":[{"$ref":"#/components/schemas/AbstractModificationAction"},{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"action":{"description":"Use value 'ModifyPackingContainerType', because you want to modify a PackingContainerType","enum":["ModifyPackingContainerType"],"type":"string"},"dimensions":{"$ref":"#/components/schemas/ContainerDimensions"},"priority":{"description":"This value gives the priority in the respective packingContainerType. The lower the value the higher is the priority, e.g. priority 1 is higher than priority 10. The priority can be used to order PackingContainerTypes.","format":"int32","maximum":10000,"minimum":1,"type":"integer"},"weightLimitInG":{"description":"Maximal weight in gramm(gr) the container can be loaded with. ","minimum":1,"type":"number"}},"required":["action"],"type":"object"}],"description":"Action to a modify the type of a packing container.","title":"ModifyPackingContainerType","xml":{"name":"ModifyPackingContainerType"}},"AbstractModificationAction":{"discriminator":{"propertyName":"action"},"properties":{"action":{"description":"","enum":["AddAllowedValueToTag","ModifyPickJob","ModifyPickJobLastEditor","RestartPickJob","ResetPickJob","CancelPickRun","CancelHandoverjob","AbortPickJob","FinishPickRun","StartPickRun","ModifyPickLineItem","ModifyPickRunLineItem","ModifyPackJob","PausePackJob","ModifyPackLineItem","SplitLineItemsPackJob","ModifyFacility","ModifyListing","ModifyRetainedOfflineStock","ModifyListingReactivationAfter","ModifyUser","ModifyShipment","ModifyHandoverjob","ModifyCarrier","ModifyShortpick","ModifyRoutingPlan","ModifyFence","ModifyRating","ModifyTimingMode","ModifyGlobalRoutingConfiguration","ModifyOrderSplit","ModifyPrioritization","ModifyLoadUnitType","ModifyFeature","ModifyParcel","ModifyParcelLoadUnit","ModifyRestowItem","RemovePickJobFromPickRun","ModifyPartialStock","AddTagsToProcess","AssignFacilityToProcess","UpdateGdprCleanupDateAction","ModifyStorageLocation","ModifyPackingContainerType","ModifyPackingContainerTypeIcon","ReplaceCodesInPackingTargetContainer","ReplaceLoadUnitLineItems","AddLineItemToPackingTargetContainer","RemoveLineItemFromPackingTargetContainer","UpdateLineItemOnPackingTargetContainer","UpdatePackingTargetContainerLineItemRecordableAttributes","ModifyCustomService","UnlockOrder"],"type":"string"}},"required":["action"],"type":"object","xml":{"name":"AbstractModificationAction"},"title":"AbstractModificationAction","description":"AbstractModificationAction"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ContainerDimensions":{"additionalProperties":false,"properties":{"heightInCm":{"description":"The height of the container (in cm)","type":"number"},"lengthInCm":{"description":"The length of the container (in cm)","type":"number"},"weightInG":{"description":"The weight of the container (in g)","type":"number"},"widthInCm":{"description":"The width of the container (in cm)","type":"number"}},"type":"object","title":"ContainerDimensions","description":"ContainerDimensions"},"ModifyPackingContainerTypeIcon":{"allOf":[{"$ref":"#/components/schemas/AbstractModificationAction"},{"additionalProperties":false,"properties":{"action":{"description":"Use value 'ModifyPackingContainerTypeIcon', because you want to modify a PackingContainerTypes icon","enum":["ModifyPackingContainerTypeIcon"],"type":"string"},"content":{"description":"Content of the icon as base64 string","type":"string"},"name":{"description":"icons filename","type":"string"}},"required":["action","name","content"],"type":"object"}],"description":"Action to a modify the type icon of a packing container.","title":"ModifyPackingContainerTypeIcon","xml":{"name":"ModifyPackingContainerTypeIcon"}},"PackingContainerType":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"description":{"type":"string"},"dimensions":{"$ref":"#/components/schemas/ContainerDimensions"},"iconUrl":{"description":"","type":"string"},"id":{"description":"","type":"string"},"name":{"type":"string"},"priority":{"description":"This value gives the priority of the respective packingContainerType. The lower the value the higher is the priority, e.g. priority 1 is higher than priority 10. The priority can be used to order packingContainerTypes in the UI.","format":"int32","maximum":10000,"minimum":1,"type":"integer"},"weightLimitInG":{"description":"Maximal weight in gramm(gr) the container can be loaded with. ","minimum":1,"type":"number"}},"required":["id","version","nameLocalized"],"type":"object","title":"PackingContainerType","description":"PackingContainerType"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/packingcontainertypes/{packingContainerTypeId}":{"patch":{"deprecated":true,"description":"This part of the API is deprecated. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Patches a PackingContainerType with the given ID, use operative container types","operationId":"updatePackingContainerType","parameters":[{"description":"ID of the packingcontainertype you want to change","in":"path","name":"packingContainerTypeId","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PackingContainerTypePatchActions"}}},"description":"Patch set","required":true},"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PackingContainerType"}}},"description":"PackingContainerType was found & patch-set has been applied. The patched PackingContainerType is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"PackingContainerType not found"},"409":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"PackingContainerType version conflict"}},"summary":"Update packing container type","tags":["Packing (Operations)"]}}}}
```

## List packing source containers

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Listing packingSourceContainer.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"These endpoints facilitate the packing process.","name":"Packing (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"PaginatedPackingSourceContainers":{"properties":{"packingSourceContainers":{"items":{"$ref":"#/components/schemas/PackingSourceContainer"},"type":"array"},"total":{"description":"Total number of found entities for this query","type":"integer"}},"type":"object","title":"PaginatedPackingSourceContainers","description":"PaginatedPackingSourceContainers"},"PackingSourceContainer":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"codes":{"items":{"description":"Codes, that identify the container","type":"string"},"minItems":1,"type":"array"},"customAttributes":{"description":"Attributes that can be added to the packing source container. These attributes cannot be used within fulfillment processes, but it could be useful to have the information carried here.","type":"object"},"description":{"description":"Description of the packing source container in the locale the client requests.","type":"string"},"facilityRef":{"description":"Reference to the facility the packing source container is related to.","type":"string"},"iconUrl":{"description":"Url to the icon of the packing source container","type":"string"},"id":{"description":"The id of this packing source container. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"lineItems":{"items":{"$ref":"#/components/schemas/PackingSourceContainerLineItem"},"type":"array"},"loadUnitRef":{"description":"Reference to the load unit this packing source container is related to.","type":"string"},"name":{"description":"Name of the packing source container in the locale the client requests.","type":"string"},"operativeContainerTypeRef":{"description":"Reference to the assigned operativeContainerType","type":"string"},"packJobRefs":{"description":"List of references to packJobs this packing source container is related to.","items":{"type":"string"},"minItems":1,"type":"array"},"storageLocationRef":{"description":"Reference to the location where the packing source container is located.","type":"string"},"type":{"$ref":"#/components/schemas/PackingSourceContainerType"}},"required":["packJobRefs","nameLocalized","facilityRef","id","version","lastModified","created","lineItems","type"],"type":"object","title":"PackingSourceContainer","description":"PackingSourceContainer"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"PackingSourceContainerLineItem":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/MandatoryLineItem"}],"description":"item that is inside the packingSourceContainer","properties":{"article":{"$ref":"#/components/schemas/LineItemArticle"},"id":{"description":"The id of this lineItem. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"originId":{"description":"The id of the line item this line item was originated from, before any split has happened. This can be used to restore the ‘pre-split’ status.","nullable":true,"type":"string"},"quantity":{"description":"quantity of this item","format":"int64","minimum":1,"type":"integer"},"secondaryMeasurementUnitKey":{"description":"Identifier for items unit of measurement. E.g. measurementUnitKey is pieces and secondaryQuantity is gram","type":"string"},"secondaryQuantity":{"description":"secondary quantity of this item, E.g. quantity is the count and secondaryQuantity is the weight","format":"int64","minimum":1,"type":"integer"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"type":"array"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"type":"array"}},"required":["id","quantity","article"],"type":"object","xml":{"name":"PackingSourceContainerLineItem"},"title":"PackingSourceContainerLineItem"},"MandatoryLineItem":{"properties":{"article":{"description":"information about the lineItem","type":"object"},"customAttributes":{"description":"Attributes that can be added to the lineItem. These attributes cannot be used within fulfillment processes, but it could be useful to have the information carried here.","type":"object"},"globalLineItemId":{"description":"This id is used to identify if this line item is related to the line item of other operational entities.","type":"string"},"id":{"description":"id of the recordable attribute","type":"string"},"quantity":{"description":"The quantity of the lineItem","type":"number"},"recordableAttributes":{"description":"Customizable information about the lineItem that can be set during the process.","items":{"$ref":"#/components/schemas/RecordableAttribute"},"type":"array"},"scannableCodes":{"description":"Codes that can be used for scanning this lineItem","items":{"type":"string"},"type":"array"}},"required":["id","article","quantity"],"title":"MandatoryLineItem","type":"object","description":"MandatoryLineItem"},"RecordableAttribute":{"additionalProperties":false,"properties":{"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations of the key"},"group":{"description":"The group of the attribute","minLength":1,"nullable":true,"type":"string"},"id":{"description":"id of the recordable attribute","type":"string"},"key":{"description":"The translated key of the attribute. This field gets filled automatically on request","type":"string"},"originId":{"description":"The id of the original lineItem the attribute was split from.","nullable":true,"type":"string"},"recordingRule":{"description":"Indicates whether the value has to be recorded or not","enum":["OPTIONAL","MANDATORY"],"type":"string"},"value":{"description":"The value of the attribute","minLength":1,"nullable":true,"type":"string"}},"required":["id","keyLocalized","recordingRule"],"title":"RecordableAttribute","type":"object","description":"RecordableAttribute"},"LineItemArticle":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"attributes":{"description":"Attributes are used in the fulfillmenttools platform in order to impose a certain degree of customization to a process, such as improving the appearance in the platform and clients. Details about usage can be found <a href=\\\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">here</a>","items":{"$ref":"#/components/schemas/ArticleAttributeItem"},"type":"array"},"customAttributes":{"deprecated":true,"description":"deprecated: use customAttributes on lineItem instead.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this article. Please make sure that no authentication is required to fetch the image!","type":"string"},"tenantArticleId":{"description":"This is a reference to an article number","type":"string"},"title":{"description":"The title of the product","type":"string"},"weight":{"description":"weight value is in gram","minimum":0,"type":"number"}},"required":["title","tenantArticleId"],"title":"LineItemArticle","type":"object","description":"LineItemArticle"},"ArticleAttributeItem":{"properties":{"valueLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category"},"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category. Excluding for %%subtitle%%"},"category":{"description":"This category is used by OCFF to customize implemented processes.\nCategorized attributes are used by various processes and tools\nthroughout our platform. For a complete list of possible categories\nand the correct use of those please refer to the documentation.\nDefault value: miscellaneous","enum":["descriptive","miscellaneous","pickingSequence","customs","insurance","shop","dimensions","carrierService","salesPrice"],"type":"string"},"context":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItemContext"}],"description":"Context for salesPrice category and valuePerUnit key. Can only be set via Listing endpoints."},"key":{"description":"Providing the key %%subtitle%% (see example) here will cause the\nvalue to appear for example in the App directly under the title.\nWith all other attributes also the key will be displayed in the\n clients.","minLength":1,"type":"string"},"priority":{"description":"This value gives the priority in the respective attribute category.\nThe lower the value the higher is the priority, e.g. priority 1 is\nhigher than priority 10. Attributes that have the highest priority\nmight be selected for display in different articles of OCFF. Default\nValue is 1001. For details please contact the product owners.","format":"int64","maximum":1001,"minimum":1,"type":"integer"},"type":{"default":"STRING","description":"The type of the attribute.","enum":["STRING","NUMBER","CURRENCY","BOOLEAN"],"type":"string"},"value":{"minLength":1,"type":"string"}},"required":["key","value"],"title":"ArticleAttributeItem","type":"object","description":"ArticleAttributeItem"},"ArticleAttributeItemContext":{"properties":{"type":{"description":"Indicates the entity type the value refers to.","enum":["FACILITY_GROUP","FACILITY","TAG_REFERENCE"],"type":"string"},"value":{"description":"Holds the reference to the entity the attribute refers to.","minLength":1,"type":"string"}},"required":["type","value"],"title":"ArticleAttributeItemContext","type":"object","description":"ArticleAttributeItemContext"},"Sticker":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Dictionary of possible translations, min 1 entry, max 14 characters per description"},"color":{"description":"optional color coding for the sticker","type":"string"},"key":{"description":"unique identifier","type":"string"},"name":{"description":"Translated display name","type":"string"},"priority":{"description":"priority of the given sticker","format":"int64","maximum":10000,"minimum":1,"type":"integer"}},"required":["key","nameLocalized","priority"],"title":"Sticker","description":"Sticker"},"TagReference":{"properties":{"id":{"type":"string"},"value":{"type":"string"}},"required":["value","id"],"title":"TagReference","description":"TagReference"},"PackingSourceContainerType":{"description":"Type of the packing source container","enum":["VIRTUAL","PHYSICAL"],"type":"string","title":"PackingSourceContainerType"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/packingsourcecontainers":{"get":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Listing packingSourceContainer.","operationId":"getPackingSourceContainers","parameters":[{"description":"Provide the localized values for the entity. If not provided the default locale is used. For example de_DE.","in":"query","name":"locale","schema":{"type":"string"}},{"description":"all entities after given id","in":"query","name":"startAfterId","required":false,"schema":{"type":"string"}},{"description":"number of entities to show","in":"query","name":"size","required":false,"schema":{"default":25,"maximum":500,"type":"integer"}},{"description":"filter by packJobRef","in":"query","name":"packJobRef","required":false,"schema":{"type":"string"}},{"description":"filter by facilityRef","in":"query","name":"facilityRef","required":true,"schema":{"type":"string"}},{"description":"filter by scannablecodes","in":"query","name":"codes","required":false,"schema":{"items":{"type":"string"},"type":"array"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/PaginatedPackingSourceContainers"},"type":"array"}}},"description":"Found Packing Source Container"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Invalid input. See response for details"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"List packing source containers","tags":["Packing (Operations)"]}}}}
```

## Create packing source container

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Creating new packingSourceContainer.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"These endpoints facilitate the packing process.","name":"Packing (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"PackingSourceContainerForCreation":{"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"codes":{"items":{"description":"Codes, that identify the article","type":"string"},"minItems":1,"type":"array"},"customAttributes":{"description":"Attributes that can be added to the packing source container. These attributes cannot be used within fulfillment processes, but it could be useful to have the information carried here.","type":"object"},"facilityRef":{"description":"The id of the facility reference. The given ID has to be present in the system. But it is not updatable.","type":"string"},"icon":{"$ref":"#/components/schemas/NamedFile"},"lineItems":{"items":{"$ref":"#/components/schemas/PackingSourceContainerLineItemForCreation"},"type":"array"},"operativeContainerTypeRef":{"description":"Reference to the operativeContainerType, available values will be taken from the container type while creating the container","type":"string"},"packJobRefs":{"description":"List of references to packJobs","items":{"type":"string"},"minItems":1,"type":"array"},"storageLocationRef":{"description":"Reference to the location where the packing source container is located.","type":"string"}},"required":["packJobRefs","nameLocalized","facilityRef","lineItems"],"type":"object","title":"PackingSourceContainerForCreation","description":"PackingSourceContainerForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"NamedFile":{"additionalProperties":false,"properties":{"content":{"description":"File content base64 encoded","type":"string"},"name":{"description":"File name with extension","type":"string"}},"required":["name","content"],"type":"object","xml":{"name":"NamedFile"},"title":"NamedFile","description":"NamedFile"},"PackingSourceContainerLineItemForCreation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/MandatoryLineItemForCreation"}],"description":"items that are inside the packingSourceContainer","properties":{"article":{"$ref":"#/components/schemas/LineItemArticle"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"originId":{"description":"The id of the line item this line item was originated from, before any split has happened. This can be used to restore the ‘pre-split’ status.","nullable":true,"type":"string"},"quantity":{"description":"quantity of this item","format":"int64","minimum":1,"type":"integer"},"secondaryMeasurementUnitKey":{"description":"Identifier for items unit of measurement. E.g. measurementUnitKey is pieces and secondaryQuantity is gram","type":"string"},"secondaryQuantity":{"description":"secondary quantity of this item, E.g. quantity is the count and secondaryQuantity is the weight","format":"int64","minimum":1,"type":"integer"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"type":"array"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"type":"array"}},"required":["quantity","article"],"type":"object","xml":{"name":"PackingSourceContainerLineItemForCreation"},"title":"PackingSourceContainerLineItemForCreation"},"MandatoryLineItemForCreation":{"properties":{"article":{"description":"information about the lineItem","type":"object"},"customAttributes":{"description":"Attributes that can be added to the lineItem. These attributes cannot be used within fulfillment processes, but it could be useful to have the information carried here.","type":"object"},"globalLineItemId":{"description":"This id is used to identify if this line item is related to the line item of other operational entities.","type":"string"},"quantity":{"description":"The quantity of the lineItem","type":"number"},"recordableAttributes":{"description":"Customizable information about the lineItem that can be set during the process.","items":{"$ref":"#/components/schemas/RecordableAttributeForCreation"},"type":"array"},"scannableCodes":{"description":"Codes that can be used for scanning this lineItem","items":{"type":"string"},"type":"array"}},"required":["article","quantity"],"title":"MandatoryLineItemForCreation","type":"object","description":"MandatoryLineItemForCreation"},"RecordableAttributeForCreation":{"additionalProperties":false,"properties":{"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations of the key"},"group":{"description":"The group of the attribute","minLength":1,"nullable":true,"type":"string"},"recordingRule":{"description":"Indicates whether the value has to be recorded or not","enum":["OPTIONAL","MANDATORY"],"type":"string"},"value":{"description":"The value of the attribute","nullable":true,"type":"string"}},"required":["keyLocalized","recordingRule"],"title":"RecordableAttributeForCreation","type":"object","description":"RecordableAttributeForCreation"},"LineItemArticle":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"attributes":{"description":"Attributes are used in the fulfillmenttools platform in order to impose a certain degree of customization to a process, such as improving the appearance in the platform and clients. Details about usage can be found <a href=\\\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">here</a>","items":{"$ref":"#/components/schemas/ArticleAttributeItem"},"type":"array"},"customAttributes":{"deprecated":true,"description":"deprecated: use customAttributes on lineItem instead.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this article. Please make sure that no authentication is required to fetch the image!","type":"string"},"tenantArticleId":{"description":"This is a reference to an article number","type":"string"},"title":{"description":"The title of the product","type":"string"},"weight":{"description":"weight value is in gram","minimum":0,"type":"number"}},"required":["title","tenantArticleId"],"title":"LineItemArticle","type":"object","description":"LineItemArticle"},"ArticleAttributeItem":{"properties":{"valueLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category"},"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category. Excluding for %%subtitle%%"},"category":{"description":"This category is used by OCFF to customize implemented processes.\nCategorized attributes are used by various processes and tools\nthroughout our platform. For a complete list of possible categories\nand the correct use of those please refer to the documentation.\nDefault value: miscellaneous","enum":["descriptive","miscellaneous","pickingSequence","customs","insurance","shop","dimensions","carrierService","salesPrice"],"type":"string"},"context":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItemContext"}],"description":"Context for salesPrice category and valuePerUnit key. Can only be set via Listing endpoints."},"key":{"description":"Providing the key %%subtitle%% (see example) here will cause the\nvalue to appear for example in the App directly under the title.\nWith all other attributes also the key will be displayed in the\n clients.","minLength":1,"type":"string"},"priority":{"description":"This value gives the priority in the respective attribute category.\nThe lower the value the higher is the priority, e.g. priority 1 is\nhigher than priority 10. Attributes that have the highest priority\nmight be selected for display in different articles of OCFF. Default\nValue is 1001. For details please contact the product owners.","format":"int64","maximum":1001,"minimum":1,"type":"integer"},"type":{"default":"STRING","description":"The type of the attribute.","enum":["STRING","NUMBER","CURRENCY","BOOLEAN"],"type":"string"},"value":{"minLength":1,"type":"string"}},"required":["key","value"],"title":"ArticleAttributeItem","type":"object","description":"ArticleAttributeItem"},"ArticleAttributeItemContext":{"properties":{"type":{"description":"Indicates the entity type the value refers to.","enum":["FACILITY_GROUP","FACILITY","TAG_REFERENCE"],"type":"string"},"value":{"description":"Holds the reference to the entity the attribute refers to.","minLength":1,"type":"string"}},"required":["type","value"],"title":"ArticleAttributeItemContext","type":"object","description":"ArticleAttributeItemContext"},"Sticker":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Dictionary of possible translations, min 1 entry, max 14 characters per description"},"color":{"description":"optional color coding for the sticker","type":"string"},"key":{"description":"unique identifier","type":"string"},"name":{"description":"Translated display name","type":"string"},"priority":{"description":"priority of the given sticker","format":"int64","maximum":10000,"minimum":1,"type":"integer"}},"required":["key","nameLocalized","priority"],"title":"Sticker","description":"Sticker"},"TagReference":{"properties":{"id":{"type":"string"},"value":{"type":"string"}},"required":["value","id"],"title":"TagReference","description":"TagReference"},"PackingSourceContainer":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"codes":{"items":{"description":"Codes, that identify the container","type":"string"},"minItems":1,"type":"array"},"customAttributes":{"description":"Attributes that can be added to the packing source container. These attributes cannot be used within fulfillment processes, but it could be useful to have the information carried here.","type":"object"},"description":{"description":"Description of the packing source container in the locale the client requests.","type":"string"},"facilityRef":{"description":"Reference to the facility the packing source container is related to.","type":"string"},"iconUrl":{"description":"Url to the icon of the packing source container","type":"string"},"id":{"description":"The id of this packing source container. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"lineItems":{"items":{"$ref":"#/components/schemas/PackingSourceContainerLineItem"},"type":"array"},"loadUnitRef":{"description":"Reference to the load unit this packing source container is related to.","type":"string"},"name":{"description":"Name of the packing source container in the locale the client requests.","type":"string"},"operativeContainerTypeRef":{"description":"Reference to the assigned operativeContainerType","type":"string"},"packJobRefs":{"description":"List of references to packJobs this packing source container is related to.","items":{"type":"string"},"minItems":1,"type":"array"},"storageLocationRef":{"description":"Reference to the location where the packing source container is located.","type":"string"},"type":{"$ref":"#/components/schemas/PackingSourceContainerType"}},"required":["packJobRefs","nameLocalized","facilityRef","id","version","lastModified","created","lineItems","type"],"type":"object","title":"PackingSourceContainer","description":"PackingSourceContainer"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"PackingSourceContainerLineItem":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/MandatoryLineItem"}],"description":"item that is inside the packingSourceContainer","properties":{"article":{"$ref":"#/components/schemas/LineItemArticle"},"id":{"description":"The id of this lineItem. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"originId":{"description":"The id of the line item this line item was originated from, before any split has happened. This can be used to restore the ‘pre-split’ status.","nullable":true,"type":"string"},"quantity":{"description":"quantity of this item","format":"int64","minimum":1,"type":"integer"},"secondaryMeasurementUnitKey":{"description":"Identifier for items unit of measurement. E.g. measurementUnitKey is pieces and secondaryQuantity is gram","type":"string"},"secondaryQuantity":{"description":"secondary quantity of this item, E.g. quantity is the count and secondaryQuantity is the weight","format":"int64","minimum":1,"type":"integer"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"type":"array"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"type":"array"}},"required":["id","quantity","article"],"type":"object","xml":{"name":"PackingSourceContainerLineItem"},"title":"PackingSourceContainerLineItem"},"MandatoryLineItem":{"properties":{"article":{"description":"information about the lineItem","type":"object"},"customAttributes":{"description":"Attributes that can be added to the lineItem. These attributes cannot be used within fulfillment processes, but it could be useful to have the information carried here.","type":"object"},"globalLineItemId":{"description":"This id is used to identify if this line item is related to the line item of other operational entities.","type":"string"},"id":{"description":"id of the recordable attribute","type":"string"},"quantity":{"description":"The quantity of the lineItem","type":"number"},"recordableAttributes":{"description":"Customizable information about the lineItem that can be set during the process.","items":{"$ref":"#/components/schemas/RecordableAttribute"},"type":"array"},"scannableCodes":{"description":"Codes that can be used for scanning this lineItem","items":{"type":"string"},"type":"array"}},"required":["id","article","quantity"],"title":"MandatoryLineItem","type":"object","description":"MandatoryLineItem"},"RecordableAttribute":{"additionalProperties":false,"properties":{"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations of the key"},"group":{"description":"The group of the attribute","minLength":1,"nullable":true,"type":"string"},"id":{"description":"id of the recordable attribute","type":"string"},"key":{"description":"The translated key of the attribute. This field gets filled automatically on request","type":"string"},"originId":{"description":"The id of the original lineItem the attribute was split from.","nullable":true,"type":"string"},"recordingRule":{"description":"Indicates whether the value has to be recorded or not","enum":["OPTIONAL","MANDATORY"],"type":"string"},"value":{"description":"The value of the attribute","minLength":1,"nullable":true,"type":"string"}},"required":["id","keyLocalized","recordingRule"],"title":"RecordableAttribute","type":"object","description":"RecordableAttribute"},"PackingSourceContainerType":{"description":"Type of the packing source container","enum":["VIRTUAL","PHYSICAL"],"type":"string","title":"PackingSourceContainerType"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/packingsourcecontainers":{"post":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Creating new packingSourceContainer.","operationId":"addPackingSourceContainer","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PackingSourceContainerForCreation"}}},"description":"Packing type object","required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PackingSourceContainer"}}},"description":"The packing source container  was successfully created. The Location header contains the URL of the packing source container."},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Invalid input. See response for details"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"Create packing source container","tags":["Packing (Operations)"]}}}}
```

## Get packing source container

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Get PackingSourceContainer by ID.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"These endpoints facilitate the packing process.","name":"Packing (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"PackingSourceContainer":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString"},"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"codes":{"items":{"description":"Codes, that identify the container","type":"string"},"minItems":1,"type":"array"},"customAttributes":{"description":"Attributes that can be added to the packing source container. These attributes cannot be used within fulfillment processes, but it could be useful to have the information carried here.","type":"object"},"description":{"description":"Description of the packing source container in the locale the client requests.","type":"string"},"facilityRef":{"description":"Reference to the facility the packing source container is related to.","type":"string"},"iconUrl":{"description":"Url to the icon of the packing source container","type":"string"},"id":{"description":"The id of this packing source container. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"lineItems":{"items":{"$ref":"#/components/schemas/PackingSourceContainerLineItem"},"type":"array"},"loadUnitRef":{"description":"Reference to the load unit this packing source container is related to.","type":"string"},"name":{"description":"Name of the packing source container in the locale the client requests.","type":"string"},"operativeContainerTypeRef":{"description":"Reference to the assigned operativeContainerType","type":"string"},"packJobRefs":{"description":"List of references to packJobs this packing source container is related to.","items":{"type":"string"},"minItems":1,"type":"array"},"storageLocationRef":{"description":"Reference to the location where the packing source container is located.","type":"string"},"type":{"$ref":"#/components/schemas/PackingSourceContainerType"}},"required":["packJobRefs","nameLocalized","facilityRef","id","version","lastModified","created","lineItems","type"],"type":"object","title":"PackingSourceContainer","description":"PackingSourceContainer"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"PackingSourceContainerLineItem":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/MandatoryLineItem"}],"description":"item that is inside the packingSourceContainer","properties":{"article":{"$ref":"#/components/schemas/LineItemArticle"},"id":{"description":"The id of this lineItem. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"originId":{"description":"The id of the line item this line item was originated from, before any split has happened. This can be used to restore the ‘pre-split’ status.","nullable":true,"type":"string"},"quantity":{"description":"quantity of this item","format":"int64","minimum":1,"type":"integer"},"secondaryMeasurementUnitKey":{"description":"Identifier for items unit of measurement. E.g. measurementUnitKey is pieces and secondaryQuantity is gram","type":"string"},"secondaryQuantity":{"description":"secondary quantity of this item, E.g. quantity is the count and secondaryQuantity is the weight","format":"int64","minimum":1,"type":"integer"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"type":"array"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"type":"array"}},"required":["id","quantity","article"],"type":"object","xml":{"name":"PackingSourceContainerLineItem"},"title":"PackingSourceContainerLineItem"},"MandatoryLineItem":{"properties":{"article":{"description":"information about the lineItem","type":"object"},"customAttributes":{"description":"Attributes that can be added to the lineItem. These attributes cannot be used within fulfillment processes, but it could be useful to have the information carried here.","type":"object"},"globalLineItemId":{"description":"This id is used to identify if this line item is related to the line item of other operational entities.","type":"string"},"id":{"description":"id of the recordable attribute","type":"string"},"quantity":{"description":"The quantity of the lineItem","type":"number"},"recordableAttributes":{"description":"Customizable information about the lineItem that can be set during the process.","items":{"$ref":"#/components/schemas/RecordableAttribute"},"type":"array"},"scannableCodes":{"description":"Codes that can be used for scanning this lineItem","items":{"type":"string"},"type":"array"}},"required":["id","article","quantity"],"title":"MandatoryLineItem","type":"object","description":"MandatoryLineItem"},"RecordableAttribute":{"additionalProperties":false,"properties":{"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations of the key"},"group":{"description":"The group of the attribute","minLength":1,"nullable":true,"type":"string"},"id":{"description":"id of the recordable attribute","type":"string"},"key":{"description":"The translated key of the attribute. This field gets filled automatically on request","type":"string"},"originId":{"description":"The id of the original lineItem the attribute was split from.","nullable":true,"type":"string"},"recordingRule":{"description":"Indicates whether the value has to be recorded or not","enum":["OPTIONAL","MANDATORY"],"type":"string"},"value":{"description":"The value of the attribute","minLength":1,"nullable":true,"type":"string"}},"required":["id","keyLocalized","recordingRule"],"title":"RecordableAttribute","type":"object","description":"RecordableAttribute"},"LineItemArticle":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"attributes":{"description":"Attributes are used in the fulfillmenttools platform in order to impose a certain degree of customization to a process, such as improving the appearance in the platform and clients. Details about usage can be found <a href=\\\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">here</a>","items":{"$ref":"#/components/schemas/ArticleAttributeItem"},"type":"array"},"customAttributes":{"deprecated":true,"description":"deprecated: use customAttributes on lineItem instead.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this article. Please make sure that no authentication is required to fetch the image!","type":"string"},"tenantArticleId":{"description":"This is a reference to an article number","type":"string"},"title":{"description":"The title of the product","type":"string"},"weight":{"description":"weight value is in gram","minimum":0,"type":"number"}},"required":["title","tenantArticleId"],"title":"LineItemArticle","type":"object","description":"LineItemArticle"},"ArticleAttributeItem":{"properties":{"valueLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category"},"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category. Excluding for %%subtitle%%"},"category":{"description":"This category is used by OCFF to customize implemented processes.\nCategorized attributes are used by various processes and tools\nthroughout our platform. For a complete list of possible categories\nand the correct use of those please refer to the documentation.\nDefault value: miscellaneous","enum":["descriptive","miscellaneous","pickingSequence","customs","insurance","shop","dimensions","carrierService","salesPrice"],"type":"string"},"context":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItemContext"}],"description":"Context for salesPrice category and valuePerUnit key. Can only be set via Listing endpoints."},"key":{"description":"Providing the key %%subtitle%% (see example) here will cause the\nvalue to appear for example in the App directly under the title.\nWith all other attributes also the key will be displayed in the\n clients.","minLength":1,"type":"string"},"priority":{"description":"This value gives the priority in the respective attribute category.\nThe lower the value the higher is the priority, e.g. priority 1 is\nhigher than priority 10. Attributes that have the highest priority\nmight be selected for display in different articles of OCFF. Default\nValue is 1001. For details please contact the product owners.","format":"int64","maximum":1001,"minimum":1,"type":"integer"},"type":{"default":"STRING","description":"The type of the attribute.","enum":["STRING","NUMBER","CURRENCY","BOOLEAN"],"type":"string"},"value":{"minLength":1,"type":"string"}},"required":["key","value"],"title":"ArticleAttributeItem","type":"object","description":"ArticleAttributeItem"},"ArticleAttributeItemContext":{"properties":{"type":{"description":"Indicates the entity type the value refers to.","enum":["FACILITY_GROUP","FACILITY","TAG_REFERENCE"],"type":"string"},"value":{"description":"Holds the reference to the entity the attribute refers to.","minLength":1,"type":"string"}},"required":["type","value"],"title":"ArticleAttributeItemContext","type":"object","description":"ArticleAttributeItemContext"},"Sticker":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Dictionary of possible translations, min 1 entry, max 14 characters per description"},"color":{"description":"optional color coding for the sticker","type":"string"},"key":{"description":"unique identifier","type":"string"},"name":{"description":"Translated display name","type":"string"},"priority":{"description":"priority of the given sticker","format":"int64","maximum":10000,"minimum":1,"type":"integer"}},"required":["key","nameLocalized","priority"],"title":"Sticker","description":"Sticker"},"TagReference":{"properties":{"id":{"type":"string"},"value":{"type":"string"}},"required":["value","id"],"title":"TagReference","description":"TagReference"},"PackingSourceContainerType":{"description":"Type of the packing source container","enum":["VIRTUAL","PHYSICAL"],"type":"string","title":"PackingSourceContainerType"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/packingsourcecontainers/{packingSourceContainerId}":{"get":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Get PackingSourceContainer by ID.","operationId":"getPackingSourceContainerById","parameters":[{"description":"ID of the packingSourceContainer","in":"path","name":"packingSourceContainerId","required":true,"schema":{"type":"string"}},{"description":"Provide the localized values for the entity. If not provided the default locale is used. For example de_DE.","in":"query","name":"locale","schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/PackingSourceContainer"},"type":"array"}}},"description":"Found packingSourceContainer"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Invalid input. See response for details"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity not found"}},"summary":"Get packing source container","tags":["Packing (Operations)"]}}}}
```

## GET /api/packjobs

> List pack jobs

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"These endpoints facilitate the packing process.","name":"Packing (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"PackJobOrderBy":{"description":"Attribute to order a packJobs by","enum":["TARGET_TIME_DESC","TARGET_TIME_ASC","LAST_MODIFIED_DESC","LAST_MODIFIED_ASC","ORDER_DATE_DESC","ORDER_DATE_ASC"],"type":"string","xml":{"name":"PackJobOrderBy"},"title":"PackJobOrderBy"},"PackJobs":{"properties":{"packJobs":{"items":{"$ref":"#/components/schemas/PackJobWithSearchPath"},"type":"array"},"total":{"description":"Total number of found entities for this query","type":"integer"}},"type":"object","title":"PackJobs","description":"PackJobs"},"PackJobWithSearchPath":{"allOf":[{"$ref":"#/components/schemas/PackJob"},{"additionalProperties":false}],"properties":{"searchPaths":{"items":{"type":"string"},"minItems":0,"type":"array"}},"xml":{"name":"PackJobWithPath"},"title":"PackJobWithSearchPath","description":"PackJobWithSearchPath"},"PackJob":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"anonymized":{"description":"Indicates if gdpr related data was anonymized","type":"boolean"},"assignedUsers":{"description":"Assigned users for this entity","items":{"$ref":"#/components/schemas/AssignedUser"},"type":"array"},"customAttributes":{"description":"Attributes that can be added to the pack job. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"deliveryChannel":{"enum":["COLLECT","SHIPPING"],"type":"string"},"documentHandling":{"$ref":"#/components/schemas/DocumentHandling"},"documentsRef":{"description":"Reference to the documents collection from this entity","type":"string"},"editor":{"$ref":"#/components/schemas/Editor"},"facilityRef":{"description":"Reference to the facility you want to get the corresponding packjob","type":"string"},"id":{"description":"The id of this pack job. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"invoice":{"$ref":"#/components/schemas/ConsumerAddress"},"lineItems":{"items":{"$ref":"#/components/schemas/PackLineItem"},"type":"array"},"operativeProcessRef":{"type":"string"},"orderDate":{"description":"Date when the order was placed.","format":"date-time","type":"string"},"orderRef":{"description":"The id of the order","type":"string"},"packingSourceContainers":{"items":{"$ref":"#/components/schemas/StrippedPackingSourceContainer"}},"pickJobRef":{"description":"Reference to a pick job","type":"string"},"processId":{"description":"Id of the global process related to this entity. For example used for starting the GDPR process and others.","type":"string"},"recipient":{"$ref":"#/components/schemas/ConsumerAddress"},"recipientName":{"description":"The name of the recipient","type":"string"},"shortId":{"description":"The short identifier of the shipment.","type":"string"},"status":{"$ref":"#/components/schemas/PackJobStatus"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"type":"array"},"targetTime":{"description":"Until when the pack job must be finished.","format":"date-time","type":"string"},"tenantOrderId":{"type":"string"},"transfers":{"items":{"$ref":"#/components/schemas/OperativeTransfer"},"minItems":0,"type":"array"},"workflowInformation":{"oneOf":[{"$ref":"#/components/schemas/WorkflowInformation"},{"$ref":"#/components/schemas/WorkflowUnavailable"}]},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"minItems":1,"type":"array"}},"required":["id","facilityRef","documentsRef","status","lineItems","processId","workflowInformation"],"type":"object","xml":{"name":"PackJob"}}],"title":"PackJob","description":"PackJob"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"AssignedUser":{"properties":{"userId":{"description":"ID of the user who is assigned","type":"string"},"username":{"description":"username of the user who is assigned","type":"string"}},"required":["username","userId"],"type":"object","title":"AssignedUser","description":"AssignedUser"},"DocumentHandling":{"properties":{"sendLabel":{"properties":{"enabled":{"default":false,"type":"boolean"}},"required":["enabled"],"type":"object"}},"required":["sendLabel"],"type":"object","title":"DocumentHandling","description":"DocumentHandling"},"Editor":{"properties":{"userId":{"description":"ID of the user who edits the pickjob","type":"string"},"username":{"description":"username of the user who edits the pickjob","type":"string"}},"required":["username"],"type":"object","title":"Editor","description":"Editor"},"ConsumerAddress":{"allOf":[{"$ref":"#/components/schemas/Address"}],"properties":{"addressType":{"$ref":"#/components/schemas/AddressType"},"companyName":{"type":"string"},"coordinates":{"$ref":"#/components/schemas/Coordinates"},"email":{"format":"email","minLength":1,"type":"string"},"firstName":{"type":"string"},"lastName":{"type":"string"},"personalTitle":{"type":"string"},"salutation":{"type":"string"}},"type":"object","title":"ConsumerAddress","description":"ConsumerAddress"},"Address":{"properties":{"additionalAddressInfo":{"type":"string"},"city":{"pattern":"^.+$","type":"string"},"country":{"description":"A two-digit country code as per ISO 3166-1 alpha-2","pattern":"^[A-Z]{2}$","type":"string"},"customAttributes":{"description":"Attributes that can be added to the address. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"houseNumber":{"pattern":"^.+$","type":"string"},"phoneNumbers":{"items":{"properties":{"customAttributes":{"description":"Attributes that can be added to the phonenumber. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"label":{"description":"Can be used to give a description for the number, like \"private\", \"business number\", etc.","type":"string"},"type":{"enum":["MOBILE","PHONE"],"type":"string"},"value":{"description":"The number itself. We do not enforce any format (yet).","type":"string"}},"required":["value","type"],"type":"object"},"type":"array"},"postalCode":{"pattern":"^.+$","type":"string"},"province":{"pattern":"^.+$","type":"string"},"street":{"pattern":"^.+$","type":"string"}},"required":["street","city","postalCode","country"],"type":"object","title":"Address","description":"Address"},"AddressType":{"description":"Type of this address, used e.g. for communication with the carrier. Use POSTAL_ADDRESS for the address where the order should be shipped to, INVOICE_ADDRESS for the address where the invoice is sent to and PARCEL_LOCKER if a parcel locker is used for this order.","enum":["POSTAL_ADDRESS","PARCEL_LOCKER","INVOICE_ADDRESS"],"type":"string","title":"AddressType"},"Coordinates":{"description":"Coordinates of the WGS84 geodetic reference system in Mercator projection, as used e.g. by the Google Maps API","properties":{"lat":{"description":"Latitude value","type":"number"},"lon":{"description":"Longitude value","type":"number"}},"required":["lat","lon"],"type":"object","title":"Coordinates"},"PackLineItem":{"allOf":[{"$ref":"#/components/schemas/MandatoryLineItem"},{"properties":{"article":{"$ref":"#/components/schemas/PackLineItemArticle"},"id":{"description":"The id of this lineItem. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"originId":{"description":"The id of the line item this line item was originated from, before any split has happened. This can be used to restore the ‘pre-split’ status.","nullable":true,"type":"string"},"packed":{"description":"The amount of articles that were packed for this packline.","format":"int32","minimum":0,"type":"integer"},"quantity":{"description":"quantity of this item","format":"int64","minimum":1,"type":"integer"},"serviceJobRefs":{"description":"Reference to the service job that has altered this line item","items":{"type":"string"},"type":"array"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"type":"array"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"type":"array"}},"required":["id","quantity","article"]}],"type":"object","xml":{"name":"PackLineItem"},"title":"PackLineItem","description":"PackLineItem"},"MandatoryLineItem":{"properties":{"article":{"description":"information about the lineItem","type":"object"},"customAttributes":{"description":"Attributes that can be added to the lineItem. These attributes cannot be used within fulfillment processes, but it could be useful to have the information carried here.","type":"object"},"globalLineItemId":{"description":"This id is used to identify if this line item is related to the line item of other operational entities.","type":"string"},"id":{"description":"id of the recordable attribute","type":"string"},"quantity":{"description":"The quantity of the lineItem","type":"number"},"recordableAttributes":{"description":"Customizable information about the lineItem that can be set during the process.","items":{"$ref":"#/components/schemas/RecordableAttribute"},"type":"array"},"scannableCodes":{"description":"Codes that can be used for scanning this lineItem","items":{"type":"string"},"type":"array"}},"required":["id","article","quantity"],"title":"MandatoryLineItem","type":"object","description":"MandatoryLineItem"},"RecordableAttribute":{"additionalProperties":false,"properties":{"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations of the key"},"group":{"description":"The group of the attribute","minLength":1,"nullable":true,"type":"string"},"id":{"description":"id of the recordable attribute","type":"string"},"key":{"description":"The translated key of the attribute. This field gets filled automatically on request","type":"string"},"originId":{"description":"The id of the original lineItem the attribute was split from.","nullable":true,"type":"string"},"recordingRule":{"description":"Indicates whether the value has to be recorded or not","enum":["OPTIONAL","MANDATORY"],"type":"string"},"value":{"description":"The value of the attribute","minLength":1,"nullable":true,"type":"string"}},"required":["id","keyLocalized","recordingRule"],"title":"RecordableAttribute","type":"object","description":"RecordableAttribute"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"PackLineItemArticle":{"allOf":[{"$ref":"#/components/schemas/AbstractArticle"},{"properties":{"attributes":{"items":{"$ref":"#/components/schemas/ArticleAttributeItem"},"maxItems":40,"type":"array"}},"type":"object"}],"xml":{"name":"PackLineItemArticle"},"title":"PackLineItemArticle","description":"PackLineItemArticle"},"AbstractArticle":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this article. Please make sure that no authentication is required to fetch the image!","type":"string"},"tenantArticleId":{"description":"This is a reference to an article number","type":"string"},"title":{"description":"The title of the product","type":"string"},"weight":{"description":"weight value is in gram","minimum":0,"type":"number"}},"required":["tenantArticleId","title"],"title":"AbstractArticle","type":"object","description":"AbstractArticle"},"ArticleAttributeItem":{"properties":{"valueLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category"},"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category. Excluding for %%subtitle%%"},"category":{"description":"This category is used by OCFF to customize implemented processes.\nCategorized attributes are used by various processes and tools\nthroughout our platform. For a complete list of possible categories\nand the correct use of those please refer to the documentation.\nDefault value: miscellaneous","enum":["descriptive","miscellaneous","pickingSequence","customs","insurance","shop","dimensions","carrierService","salesPrice"],"type":"string"},"context":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItemContext"}],"description":"Context for salesPrice category and valuePerUnit key. Can only be set via Listing endpoints."},"key":{"description":"Providing the key %%subtitle%% (see example) here will cause the\nvalue to appear for example in the App directly under the title.\nWith all other attributes also the key will be displayed in the\n clients.","minLength":1,"type":"string"},"priority":{"description":"This value gives the priority in the respective attribute category.\nThe lower the value the higher is the priority, e.g. priority 1 is\nhigher than priority 10. Attributes that have the highest priority\nmight be selected for display in different articles of OCFF. Default\nValue is 1001. For details please contact the product owners.","format":"int64","maximum":1001,"minimum":1,"type":"integer"},"type":{"default":"STRING","description":"The type of the attribute.","enum":["STRING","NUMBER","CURRENCY","BOOLEAN"],"type":"string"},"value":{"minLength":1,"type":"string"}},"required":["key","value"],"title":"ArticleAttributeItem","type":"object","description":"ArticleAttributeItem"},"ArticleAttributeItemContext":{"properties":{"type":{"description":"Indicates the entity type the value refers to.","enum":["FACILITY_GROUP","FACILITY","TAG_REFERENCE"],"type":"string"},"value":{"description":"Holds the reference to the entity the attribute refers to.","minLength":1,"type":"string"}},"required":["type","value"],"title":"ArticleAttributeItemContext","type":"object","description":"ArticleAttributeItemContext"},"Sticker":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Dictionary of possible translations, min 1 entry, max 14 characters per description"},"color":{"description":"optional color coding for the sticker","type":"string"},"key":{"description":"unique identifier","type":"string"},"name":{"description":"Translated display name","type":"string"},"priority":{"description":"priority of the given sticker","format":"int64","maximum":10000,"minimum":1,"type":"integer"}},"required":["key","nameLocalized","priority"],"title":"Sticker","description":"Sticker"},"TagReference":{"properties":{"id":{"type":"string"},"value":{"type":"string"}},"required":["value","id"],"title":"TagReference","description":"TagReference"},"StrippedPackingSourceContainer":{"additionalProperties":false,"properties":{"codes":{"items":{"description":"Codes, that identify the container","type":"string"},"minItems":1,"type":"array"},"id":{"type":"string"},"loadUnitRef":{"type":"string"}},"type":"object","title":"StrippedPackingSourceContainer","description":"StrippedPackingSourceContainer"},"PackJobStatus":{"description":"A pack job initially has the status OPEN and packing can start. When packing has started, the pack job changes its status to IN_PROGRESS. After a pack job has been completely packed its status becomes CLOSED.","enum":["OPEN","IN_PROGRESS","CLOSED","OBSOLETE","CANCELED","PAUSED"],"type":"string","xml":{"name":"PackJobStatus"},"title":"PackJobStatus"},"OperativeTransfer":{"additionalProperties":false,"properties":{"id":{"description":"The id of the transfer","type":"string"},"type":{"description":"The type of the transfer","enum":["SUPPLIER","RECEIVER"],"type":"string"}},"required":["id","type"],"title":"OperativeTransfer","type":"object","description":"OperativeTransfer"},"WorkflowInformation":{"additionalProperties":false,"properties":{"instanceRef":{"description":"The id identifying the workflow instance this entity belongs to.","type":"string"},"isAvailable":{"description":"Explicitly states if this entity is part of a workflow.","enum":[true],"type":"boolean"},"nodeRef":{"description":"The id identifying the node within the workflow instance tha this entity belongs to.","type":"string"}},"title":"WorkflowInformation","type":"object","description":"WorkflowInformation"},"WorkflowUnavailable":{"additionalProperties":false,"properties":{"isAvailable":{"description":"Explicitly states if this entity is part of a workflow.","enum":[false],"type":"boolean"}},"title":"WorkflowUnavailable","type":"object","description":"WorkflowUnavailable"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/packjobs":{"get":{"description":"","operationId":"getPackJobs","parameters":[{"description":"number of entities to show","in":"query","name":"size","required":false,"schema":{"default":25,"type":"integer"}},{"description":"all entities after given Id","in":"query","name":"startAfterId","required":false,"schema":{"type":"string"}},{"description":"Parameter to filter anonymized pack jobs","in":"query","name":"anonymized","required":false,"schema":{"type":"boolean"}},{"description":"Reference the assigned user on this entity - id or username","in":"query","name":"assignedUser","required":false,"schema":{"type":"string"}},{"description":"Reference to the status you want to get the corresponding packJobs","explode":false,"in":"query","name":"status","required":false,"schema":{"items":{"type":"string"},"type":"array"}},{"description":"Reference to the facility you want to get the corresponding packJobs","in":"query","name":"facilityRef","required":false,"schema":{"type":"string"}},{"description":"Term by which to search through the fields","in":"query","name":"searchTerm","required":false,"schema":{"type":"string"}},{"description":"Reference to the channel you want to get the corresponding packJobs","in":"query","name":"channel","required":false,"schema":{"enum":["COLLECT","SHIPPING"],"type":"string"}},{"description":"filter by packingsourcecontainer containing codes","in":"query","name":"sourceContainerCodes","required":false,"schema":{"items":{"type":"string"},"type":"array"}},{"description":"query packjobs orderBy","in":"query","name":"orderBy","required":false,"schema":{"$ref":"#/components/schemas/PackJobOrderBy"}},{"description":"Start date range for pack jobs","in":"query","name":"startTargetTime","required":false,"schema":{"format":"date-time","type":"string"}},{"description":"End date range for pack jobs","in":"query","name":"endTargetTime","required":false,"schema":{"format":"date-time","type":"string"}},{"description":"Reference to the order you want to get the corresponding packJobs","in":"query","name":"orderRef","required":false,"schema":{"type":"string"}},{"description":"Reference to the packJobs you want to get","in":"query","name":"packJobIds","required":false,"schema":{"items":{"type":"string"},"type":"array"}},{"description":"Reference to the process you want to get the corresponding packJobs","in":"query","name":"processId","required":false,"schema":{"type":"string"}},{"description":"Reference to the pickJobRef you want to get the corresponding packJobs","in":"query","name":"pickJobRef","required":false,"schema":{"type":"string"}},{"description":"Reference to the shortId you want to get the corresponding packJobs","in":"query","name":"shortId","required":false,"schema":{"type":"string"}},{"description":"Reference to the articleTitle you want to get the corresponding packJobs","in":"query","name":"articleTitle","required":false,"schema":{"type":"string"}},{"description":"Start date range of the order for the corresponding pack jobs","in":"query","name":"startOrderDate","required":false,"schema":{"format":"date-time","type":"string"}},{"description":"End date range of the order for the corresponding pack jobs","in":"query","name":"endOrderDate","required":false,"schema":{"format":"date-time","type":"string"}},{"description":"Reference to the username you want to get the corresponding pack jobs","in":"query","name":"modifiedByUsername","required":false,"schema":{"type":"string"}},{"description":"Reference to the tenantOrderId you want to get the corresponding packJobs","in":"query","name":"tenantOrderId","required":false,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PackJobs"}}},"description":"Pack jobs was loaded & you were allowed to access it. The result is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity not found"}},"summary":"List pack jobs","tags":["Packing (Operations)"]}}}}
```

## POST /api/packjobs

> Create pack job

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"These endpoints facilitate the packing process.","name":"Packing (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"PackJobForCreation":{"additionalProperties":false,"properties":{"assignedUsers":{"description":"Assigned users for this entity","items":{"anyOf":[{"$ref":"#/components/schemas/AssignedUserForCreationByName"},{"$ref":"#/components/schemas/AssignedUserForCreationById"}]},"type":"array"},"customAttributes":{"description":"Attributes that can be added to the pack job. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"deliveryChannel":{"enum":["COLLECT","SHIPPING"],"type":"string"},"facilityRef":{"description":"Reference to the facility you want to get the corresponding packjob","type":"string"},"invoice":{"$ref":"#/components/schemas/ConsumerAddress"},"lineItems":{"items":{"$ref":"#/components/schemas/PackLineItemForCreation"},"type":"array"},"operativeProcessRef":{"type":"string"},"orderDate":{"description":"Date when the order was placed.","format":"date-time","type":"string"},"orderRef":{"description":"The id of the order","type":"string"},"pickJobRef":{"description":"Reference to a pick job","type":"string"},"processId":{"description":"Id of the global process related to this entity. For example used for starting the GDPR process and others.","type":"string"},"recipient":{"$ref":"#/components/schemas/ConsumerAddress"},"recipientName":{"description":"The name of the recipient","type":"string"},"shortId":{"description":"The short identifier of the shipment.","type":"string"},"status":{"$ref":"#/components/schemas/PackJobStatus"},"targetTime":{"description":"Until when the pack job must be finished.","format":"date-time","type":"string"},"tenantOrderId":{"type":"string"},"transfers":{"items":{"$ref":"#/components/schemas/OperativeTransfer"},"minItems":0,"type":"array"},"workflowInformation":{"oneOf":[{"$ref":"#/components/schemas/WorkflowInformation"},{"$ref":"#/components/schemas/WorkflowUnavailable"}]},"tags":{"description":"Tags can only be set when there is no process related with this packJob. Setting processId and tags will lead to an validationError.","items":{"$ref":"#/components/schemas/TagReference"},"minItems":1,"type":"array"}},"required":["facilityRef","lineItems","workflowInformation"],"type":"object","xml":{"name":"PackJobForCreation"},"title":"PackJobForCreation","description":"PackJobForCreation"},"AssignedUs
[...]
